All Edge releases of Self-hosted Retool
All release notes for the Edge channel of Self-hosted Retool
Text version of release notes for the Edge channel of Self-hosted Retool. Use the Self-hosted Retool release notes app to search and compare changes between versions.
Self-hosted Retool 3.371
Latest releaseCurrently supported
Patch release notes
Apr 15, 2026
added
- Added ServiceNow resource type for self-hosted deployments.
- Added commit signing support for GitLab source control integrations.
- Enabled ProtoJSON format for gRPC resource queries on self-hosted deployments.
- Added support for the resource indicator parameter (RFC 8707) in OAuth 2.0 resource connections.
- Added image generation support for Google Gemini resources using
gemini-3.1-flash-image-previewandgemini-3-pro-image-previewmodels. - Added CockroachDB resource type with connection string autofill support.
- Added Jump to Today button to the Timeline component toolbar.
- Added query redaction setting to the audit log configuration in organization settings.
- Added GCS support for workflow block result storage via
WORKFLOW_BLOCK_STORAGE_LOCATION=gcs. - Added
SNOWFLAKE_VALIDATION_DISABLE_HEARTBEATenvironment variable for Snowflake connection management on self-hosted deployments.
fixed
- Fixed app loading issue that prevented clicking on apps from the home page.
- Fixed OAuth2 resources to require re-authentication when not already in an authenticated state.
- Fixed an issue with components that had dynamic heights.
- Fixed race condition in the OpenAPI query editor that could overwrite user-edited parameter values.
- Fixed multipage app navigation for page URL slugs that included leading slashes.
- Fixed app saves being dropped when multiplayer mode falls back to single-user mode.
improved
- Improved MongoDB resource to surface
value too longerrors as user-visible errors. - Improved Table component column width tooltip to accurately describe proportional distribution behavior.
security-fix
- Upgraded
scikit-learnfrom 1.2.1 to 1.5.0 in the code executor sandbox environment. Fixes CVE-2024-5206. - Upgraded
yamlpackage to address a denial-of-service vulnerability. Fixes CVE-2026-33532. - Upgraded
http-proxy-middlewarein frontend to address a cross-site scripting vulnerability. Fixes CVE-2024-21536. - Upgraded
Node.jsfrom 22.22.0 to 22.22.2 in Docker images. Fixes CVE-2026-21637. - Upgraded
esbuildin code executor and workflow code executor to address Go standard library vulnerabilities. - Applied security patches for
node-forge,minimatch, andbrace-expansiondependencies. - Removed unauthenticated
/workflows/sendTestEmailendpoint to prevent potential abuse.
Self-hosted Retool 3.367
No longer supported
Patch release notes
Apr 8, 2026
added
- Added audit logging for workflow events including renames, trigger configuration changes, releases, protection toggles, and custom URL path changes.
- Added a
DELETE /api/v2/workflows/:workflowIdendpoint to the public REST API for deleting workflows programmatically. - Added a Manage user seats permission scope for controlling seat management in custom role configurations.
- Added a link in the help menu to navigate to the local per-instance API reference.
- Added plan-tier badges and a plan filter to the per-instance
/referenceAPI documentation page.
fixed
- Fixed OAuth authentication failures being silently swallowed when the DBCS pipe was enabled, causing errors to go unreported.
- Fixed XML query responses returning
undefinedforrawXmlandparsedXmlproperties when the DBCS pipe was enabled. - Fixed Query Library showing raw error data as a successful result instead of displaying the error when the DBCS pipe was enabled.
- Fixed a crash in the DBCS XML response transformer by replacing
xml2jswithfast-xml-parser. - Fixed a 500 error on the
PATCH /api/resources/names/:resourceNameendpoint caused by a foreign key constraint violation when creating a new environment-specific resource. - Fixed a 500 error in the save query endpoint when the
dataparameter was missing, null, or not a valid JSON object. - Fixed queries in modules failing to execute on page load due to a race condition between model lookup and eager query trigger.
- Fixed
current_user.groupsreturning a literal string instead of a group array in apps using custom auth flows. - Fixed an issue where setting Table row height to
dynamicprogrammatically did not properly enable dynamic row heights. - Fixed the Table component's Regenerate Columns feature only detecting columns from the first 10 rows of data.
- Fixed an error with mobile apps that caused screens to stop rendering.
- Fixed parent workflows showing a generic failure message instead of the actual error when a child workflow fails.
- Fixed the branch reset modal accepting unknown branch names that could not be matched to a real remote branch.
- Fixed the legacy Retool AI resource becoming uneditable when version control was locked.
- Fixed saving changes to a Retool Database resource configuration throwing a
badDataerror due to incorrect deep equality comparison for nested option objects. - Fixed a memory leak in the on-premises proxy by automatically cleaning up aborted upstream socket connections.
- Fixed a false-positive "Workflow Backend Egress" health check appearing on the Code Executor card in the Services Debugging page.
- Fixed the Secrets Manager test connection endpoint to require admin permissions, and updated the UI to use the correct current API endpoint.
- Fixed system-scoped roles that are required for direct sharing from being deleted.
- Fixed the permission assignment modal displaying a resource's internal name instead of its display name on the Roles and Permissions settings page.
- Fixed scope selection in the Roles and Permissions UI to correctly enforce dependent scope graph constraints.
- Fixed multiplayer showing a persistent loading state when a WebSocket upgrade fails due to a permanent authentication error, now immediately displaying the error.
- Fixed mobile app query failures clearing
rawDatawhen the raw query payload was available. - Fixed blank screens, missing version info in settings, and JSON parsing errors on Android.
improved
- Improved app availability when multiplayer fails to connect — apps now fall back to single-user editing instead of showing a blocking overlay.
- Improved error messaging when an app edit session fails due to authorization, now showing the specific error instead of a generic message.
- Improved the Resources page to show a toast notification when a user attempts to access a resource they do not have permission to view.
- Improved the organization scope creation modal with collapsible sections and selection count badges.
- Extended time duration parsing to support compound strings such as
'2m10s'or'1m30s500ms'in addition to single-unit values. - Increased the multiplayer sync message batch size from 10 to 50 to reduce message overhead during collaborative editing.
- Clarified the wording of the truncated block results banner in the workflow Run history log viewer.
changed
- Renamed the role context menu action from Edit to Change name / description for clarity.
security-fix
- Upgraded
samlifyto v2.12.0 with XPath injection protection and XXE-safe XML parsing. - Fixed a vulnerability allowing a user's TOTP secret to be overwritten or 2FA disabled without verifying the existing 2FA code.
- Fixed an IDOR vulnerability allowing authenticated users to access image blobs belonging to a different organization.
- Fixed a cross-organization IDOR vulnerability allowing authenticated users to send tool approval, auth approval, and terminate signals to agent runs belonging to other organizations.
- Fixed personal access tokens being restored without re-validating scopes against current user permissions, and added audit logging for token revocation and deletion.
- Upgraded
fast-xml-parserto v5.5.6 in code-executor sandbox environments. Fixes CVE-2026-33036. - Upgraded
serialize-javascriptto v7.0.5. Fixes CVE-2026-34043. - Upgraded
node-forgefrom v1.3.3 to v1.4.0. Fixes CVE-2026-33891, CVE-2026-33894, and CVE-2026-33895. - Upgraded
brace-expansionto address a zero-step DoS vulnerability. Fixes CVE-2026-33750. - Added
picomatchoverrides to address a ReDoS vulnerability. Fixes CVE-2026-33671. - Upgraded
handlebarsto v4.7.9 in sandbox environments. Fixes CVE-2026-33937.
Self-hosted Retool 3.360
No longer supported
Patch release notes
Mar 25, 2026
added
- Added public API support for Azure Identity authentication in REST API resources.
- Added pinch-to-zoom support for Camera component in mobile apps.
- Added Python 3.14 custom library support for queries and workflows.
fixed
- Fixed Assist code validation failing when accessing properties on unknown types.
- Fixed non-builder users being able to clone pages into published folders.
- Fixed periodic query interval defaulting to 5000ms when the checkbox is unchecked.
- Fixed OAuth callback configuration failures raising 500 errors instead of 400 errors.
- Fixed Stack component width serialization using percentage-based widths instead of pixel-based widths.
- Fixed app loading errors when using invalid
_historyOffsetquery parameter values. - Fixed page name duplication on creation to prevent unique constraint errors.
- Fixed autocomplete suggestions closing the function editor dialog when clicked.
- Fixed List View Container component auto height failing to render after page refresh.
- Fixed unnecessary tooltip displaying on Publish button.
improved
- Improved Assist wireframe matching to ignore coordinates when component heights change dynamically.
- Improved Settings navigation to land users on the Requests tab when accessing
/settings/users#requests. - Improved Phone Number Input component to use image-based flag icons on Windows instead of emoji for cross-platform consistency.
- Improved Assist layout guidance for repeatable components and updated tool chip to show before/after property changes.
- Improved PostgreSQL query performance by implementing custom streaming without server-side cursors.
changed
- ⚠️ Breaking Change: Changed delete group member API endpoint parameter name from
userSidtouserId.
security-fix
- Hardened runtime sandbox.
- Fixed Set Default Theme endpoint missing an authorization check.
- Fixed email webhook handler to validate DKIM/SPF against actual email content instead of the unvalidated request body.
- Fixed a security vulnerability in the Source Control branch merging implementation.
- Updated
sequelizefrom 6.31.0 to 6.37.8 to patch CVE-2026-30951. - Updated
axiosandjsPDFto patch CVE-2026-25639 and CVE-2026-31938. - Updated
npmdependencies to patch vulnerabilities insha.js,dompurify,nanoid,react-router, anddiff. - Updated
npmdependencies to patch vulnerabilities inhono,undici,jpeg-js, andminimist. - Updated
npmdependencies in the workflows environment to patch security vulnerabilities. - Updated
npmdependencies in the sandbox environment to patch security vulnerabilities. - Updated Python dependencies in the sandbox environment to patch security vulnerabilities.
Self-hosted Retool 3.357
No longer supported
Patch release notes
Mar 18, 2026
added
- Added OpenAPI spec change detection to the guided REST API editor, automatically applying non-breaking changes and displaying a warning banner for breaking changes.
- Added Python version configuration to workflow language settings.
fixed
- Fixed Assist's REST API query tool to correctly handle existing key-value pair body formats.
- Fixed Assist always using the fallback model instead of the user-configured model.
- Fixed frame resolution incorrectly dropping when a folder node is selected in the component tree.
- Removed empty description column from the workflows table on the workflows index page.
- Fixed OAuth nonce handler firing twice in some authentication flows.
- Fixed
/api/verifyEmailendpoint crashing on malformed input. - Fixed agents metadata API timeouts that caused the Agents page to load slowly.
- Fixed image upload to enforce LLM provider size limits and compress oversized images automatically.
- Fixed Date Picker component failing to parse
date-fnsformat tokens PP, PPP, PPPP, and G. - Fixed periodic query checkbox unchecking when the interval input is cleared by backspacing.
- Fixed loop blocks incorrectly showing 'No Resource Selected' when a function runner is selected.
- Fixed collaborative editing errors when applying document updates.
- Fixed Snowflake OAuth infinite reauth loop caused by stale refresh token expiration not persisting after token refresh.
- Fixed workflow memory limit error message to show the configured
WORKFLOW_MEMORY_LIMIT_MBSvalue instead of a hardcoded number. - Fixed OAuth consent page showing generic icons for Databricks and Slack resource types.
- Fixed guided REST API editor to prevent adding duplicate Server Variable keys.
- Fixed workflow blocks to validate payload size against
RETOOL_CLIENT_MAX_BODY_SIZEand return a descriptive error for oversized payloads.
improved
- Improved the Agents page to show inline error banners instead of replacing the page when the agents API fails.
- Improved Assist in Ask mode to include database schema tools.
security-fix
- Upgraded
flattedto patch a DoS vulnerability in JSON parsing. Fixes CVE-2026-32141. - Upgraded
langchainfrom 0.0.106 to 0.3.37 to address a prompt injection vulnerability in the workflow executor. Fixes GHSA-r399-636x-v7f6. - Upgraded hono to 4.10.2 to address a JWT audience claim validation bypass. Fixes CVE-2025-62610.
- Upgraded markdown-it to 14.1.1 to address a ReDoS vulnerability via crafted markdown input. Fixes GHSA-38c4-r59v-3vqw.
- Upgraded bn.js to 5.2.3 to patch a timing side-channel vulnerability in Snowflake SDK cryptographic operations. Fixes GHSA-378v-28hj-76wf.
- Upgraded ip to 1.1.9 to patch a ReDoS vulnerability via crafted IP strings. Fixes GHSA-78xj-cgh5-2h22.
- Patched immutable from 3.7.6 to 3.8.3 to fix Prototype Pollution in draft-js and rc-editor transitive dependencies. Fixes CVE-2026-29063.
- Fixed SAML error response to no longer reflect request body or headers, preventing PII disclosure.
- Fixed approval workflow API to enforce organization ownership checks on execution updates, preventing unauthorized cross-org modifications.
Self-hosted Retool 3.355
No longer supported
Patch release notes
Mar 13, 2026
added
- Added bearer token authentication for Snowflake resources.
- Added Python 3.14 support for Python queries and transformers.
- Added
filterBysupport for Google Sheets read operations. - Added
describeanddescribeGlobaloperations for Salesforce resources. - Added static database role support for Vault secrets manager configuration.
- Added web grounding configuration support for Google Gemini resources.
- Added support for GPT-5.4 model with 1,050,000 token context window for AI resource queries.
fixed
- Fixed REST API URL parameter parsing truncating values containing
=characters. - Fixed SAML SSO login failures for identity providers whose X.509 certificates contain large OID arc values.
- Fixed
utils.copyToClipboardfailing in Safari browser. - Fixed Slack resource markdown mode toggle not bypassing HTML conversion.
- Fixed Edit Resource Modal stacking issues in workflows.
- Fixed passwordless magic link URLs to use custom domain when configured.
- Fixed Vault database engine to correctly handle 404 errors.
improved
- Improved REST API guided configuration to handle
deepObjectparameter style. - Improved REST API configuration to validate OpenAPI specification URLs.
changed
- Updated Kimi K2 model to automatically use Kimi K2.5.
- Changed audit log behavior to omit query content for improved security.
deprecated
- Deprecated Deepseek 3.2 and Kimi 0905 AI models.
security-fix
- Updated
fast-xml-parserto address CVE-2026-25896 XSS vulnerability and CVE-2026-26278 DoS vulnerability. - Updated
tardependency to address CVE-2026-26960 and CVE-2026-29786 path traversal vulnerabilities. - Updated
path-to-regexpdependency to address CVE-2024-45296 ReDoS vulnerability. - Updated
underscoredependency to address CVE-2026-27601 DoS vulnerability. - Updated
semverdependency to address CVE-2022-25883 ReDoS vulnerability. - Updated
nodemailerdependency to address CVE-2025-14874 DoS vulnerability. - Updated
basic-ftpdependency to address CVE-2026-27699 vulnerability. - Updated
jspdfdependency to address CVE-2026-25535 vulnerability. - Updated
minimatchdependency to address CVE-2026-26996 ReDoS vulnerability. - Updated
serialize-javascriptto address GHSA-5c6j-r48x-rmvq code injection vulnerability.
Self-hosted Retool 3.348
No longer supported
Patch release notes
Mar 4, 2026
added
- Added OAuth 2.0 auto-refresh support for Retool AI resources using custom AI provider endpoints.
- Added support for custom headers on REST API OAuth 2.0 token exchange and refresh requests.
- Added
DBCONNECTOR_POOL_CACHE_MAX_SIZEenvironment variable to configure the database connection pool cache size limit (default: 600). - Added
POST /api/library/foldersendpoint to create Library folders via the API. - Added
PATCH /api/library/folders/{folderId}endpoint to rename Library folders via the API. - Added
DELETE /api/library/folders/{folderId}endpoint to delete Library folders via the API. - Added
PATCH /api/library/functions/{functionId}/moveendpoint to move Backend Functions to a different Library folder via the API. - Added
PATCH /api/library/functions/{functionId}endpoint to rename Backend Functions and update their descriptions via the API. - Added public REST API support for creating and configuring Kafka, MCP, SNS, and SQS resources.
fixed
- Fixed removing an NPM package from a workflow resetting the setup script and discarding all other imported libraries.
- Fixed a "subflow not found" error that occurred when running a Backend Function immediately after renaming it.
- Fixed a
user.get is not a functionerror in audit trail middleware when the user object was a plain JavaScript object. - Added AWS RDS Proxy CA certificates to the Retool image to enable TLS connections through RDS Proxy.
- Fixed deep-linked workflow run IDs being cleared before the run history was fully loaded.
- Fixed a page crash when searching the gRPC resource schema browser.
- Fixed the Query Playground not prompting users to confirm discarding unsaved changes when clicking New.
- Fixed the code editor hover tooltip showing
unknownas the return type forsetValue()and other async widget API methods. - Fixed a 403 error on
GET /api/roleswhen a user had the external scope but external apps were disabled. - Fixed basic auth failures when using Azure DevOps repositories in Source Control in headless containers.
- Fixed audit trail logging failures caused by a
user.get is not a functionerror. - Fixed an empty tooltip appearing when hovering over transformers and variables in the app structure panel.
- Fixed the guided REST editor allowing resources to be saved after the spec URL was changed without reloading the spec.
- Fixed two bugs in the Amazon Knowledge Base update modal: Setup Required always appearing, and the modal opening for all knowledge bases instead of only the selected one.
- Fixed duplicate folders appearing in apps when multiplayer is enabled.
- Fixed a race condition in multipage apps that caused the app runtime to initialize twice on page load.
- Fixed an error when running a Retool AI vector context query using AWS Bedrock when no matching embeddings were found.
- Fixed Show on mobile and Show on desktop settings not persisting after a page refresh.
- Fixed enum values not appearing in module dropdown inputs.
- Fixed the guided REST editor freezing when switching back to a query backed by a large OpenAPI spec.
- Fixed the Last Published date not appearing in the Agents index page table view.
- Fixed dynamic template substitution in REST API form data key names, enabling
{{expression}}syntax in form data key fields. - Fixed components inside containers not rendering correctly for other collaborators when dragging components in or out of containers in multiplayer.
- Fixed misaligned tab underlines on the Settings > Groups details page.
improved
- Improved workflow block result display to show per-block truncation banners when results exceed the size limit, instead of a single run-level error that hid all block results.
- Improved Assist to support building and editing Repeatable components such as lists, grids, and galleries.
- Added Assist access scopes to the All Users role by default for new organizations.
- Removed the
assistMultipageEnabledfeature flag, making multipage support in Assist available by default. - Updated the
GET /api/library/functionsAPI endpoint to return creator names instead of user IDs.
changed
- Restricted app editor access to users with the Builder seat type.
security-fix
- Fixed a security vulnerability where users with only Use permission on resources could execute self-defined queries by calling the
/previewendpoint directly. - Fixed an IDOR vulnerability in the Agents API that allowed mismatched agent and save IDs to return unauthorized data.
Self-hosted Retool 3.344
No longer supported
Patch release notes
Feb 25, 2026
added
- Added AI README generation to the app editor, making it available to all users.
- Added support for Claude Sonnet 4.6 model in Anthropic and AWS Bedrock resource types.
- Added support for Claude Opus 4.5 model version in Anthropic and AWS Bedrock resource types.
fixed
- Fixed an issue with apps crashing in multiplayer.
- Fixed an issue with OAuth callback URL copy button not displaying correctly in Safari.
- Fixed OpenAPI connector queries failing with fetch errors in sandboxed environments.
- Fixed multiplayer errors.
- Fixed source control manifest UI incorrectly passing file paths to Bitbucket API, which caused manifest contents to be wiped.
- Fixed multiple Retool Mobile Android issues including Modal rendering with the new React Native architecture, NFC, push notifications, and Firebase-free whitelabel apps.
- Fixed an issue where GitLab source control commits failed due to incorrect encoding of commit actions.
- Fixed an issue with workflow blob storage cleanup jobs incorrectly retrying after timeout and ignoring cancellation.
- Fixed an issue with Assist leaving orphaned queries and widgets behind when deleting an app page.
- Fixed an issue with Assist incorrectly rejecting template string expressions set on boolean component properties.
improved
- Improved source control performance with batched relationship queries.
- Improved Assist's app-building accuracy with design wireframe instructions now enabled for all users.
- Improved the default workflow icon and trash menu labels on the workflows landing page.
changed
- Changed required permission level for folder delete, rename, and move to trash operations from
edittoownaccess.
deprecated
- Deprecated
chatgpt-4o-latestmodel for AI resource queries in favor of GPT-5.1. - Deprecated Claude 3.5 Haiku and Claude 3.7 Sonnet models.
security-fix
- Fixed authorization bypass vulnerability in folder deletion that allowed users without proper permissions to delete folders.
Self-hosted Retool 3.342
No longer supported
Patch release notes
Feb 19, 2026
added
- Added
CACHE_CONTROL_NO_CACHEenvironment variable to returnCache-Control: no-cache headers.
fixed
- Fixed an issue where GitLab source control commits failed due to incorrect encoding of commit actions.
- Fixed Auth0 access tokens not being invalidated when Auth0 configuration is updated on a REST resource.
- Fixed internationalization settings not syncing correctly during multiplayer app editing sessions.
- Fixed an issue where admins were unable to delete or move workflows when
VERSION_CONTROL_LOCKEDis enabled. - Fixed the email query signature suppression checkbox not being tracked as an unsaved change.
- Fixed an issue where branch syncing incorrectly deleted release artifacts, manifests, and other non-branching files during merge commits.
- Fixed an issue where branch merging failed for Azure DevOps repositories.
- Fixed custom component dev mode serving stale cached files instead of the latest revision.
- Fixed custom headers not being sent when executing Guided REST queries with JSON array request bodies.
- Fixed an issue with broken source control links in workflow and agent popovers.
- Fixed source control deployments failing when a protected app is moved into a folder with a toolscript-reserved name (such as
test,src, orlib). - Fixed Assist context window showing incorrect token counts when Anthropic prompt caching is active.
- Fixed vector queries not enforcing AI resource access permissions, preventing unauthorized users from running semantic search or creating embeddings.
improved
- Added secret autocomplete to API credential fields when configuring AI provider resources.
- Agents now display an error when the configured AI provider resource has been deleted.
- Removed unnecessary confirmation dialogs when disabling individual AI settings.
- Improved workflow block timeout error messages to clarify when a longer timeout applies only to full workflow runs.
- Improved performance for large organizations by batching dependency tracking queries to prevent backend crashes.
- Reduced database connector memory usage by loading connector drivers on demand instead of at startup.
- Improved database connector worker memory usage by ~18 MB per worker through lazy-loading SSH libraries.
- Improved backend memory usage by ~16 MB through lazy-loading vector embedding data.
- Improved Guided REST editor to fall back to cached operation data when the API spec is unavailable, and display a warning when the spec has changed.
- Improved Guided REST editor to use raw body mode with the correct Content-Type header for OpenAPI operations with array request bodies.
security-fix
- Fixed a security vulnerability in the Mailgun email webhook endpoint that could allow an unauthenticated attacker to exfiltrate the Mailgun API key.
- Upgraded jspdf to 4.1.0, fixing CVE-2026-24133, CVE-2026-24737, CVE-2026-24043, and CVE-2026-24040.
- Upgraded sharp to 0.32.6, fixing CVE-2023-4863, a high-severity heap buffer overflow in libwebp.
- Upgraded uglify-js to 2.8.29, fixing CVE-2015-8857.
Self-hosted Retool 3.338
No longer supported
Patch release notes
Feb 12, 2026
added
- Added user-configured deployment names instead of generic model IDs in dropdowns for Azure AI resources.
- Added Retool Vectors to the Workflows resource selection dropdown.
- Added support for OpenAPI server variables in REST API resources, allowing variable substitution in server URLs.
- Added protection against dangerous DROP queries with visual Dangerous badge and execution blocking.
- Added copy button to Assist chat error message hover actions.
- Added Debug Info tab to Debug Tools modal for easier troubleshooting.
- Added React Native New Architecture (TurboModules) for Android, improving runtime initialization by 88.7% and message passing by 68.8%
- Added support for embedded expressions in Source Control credentials.
- Added support for default values on configuration variables. Default values apply to any environment that does not have a specific value defined.
fixed
- Fixed validation to require server URL in structured mode and improved server selection behavior.
- Fixed an issue to enforce server variables for queries and added error messages for resolution failures.
- Fixed an issue where global error handlers for workflows would trigger even when errors were already handled by block-level On Error handlers.
- Fixed dropdown selection issues in the function canvas.
- Fixed an issue where function parameters were not updating in the canvas.
- Fixed GET requests to workflow webhook endpoints not properly passing query parameters as workflow inputs.
- Fixed UX when workflow block results are truncated due to size limits by showing run logs and hiding unusable filter button.
- Fixed icon size for editable workflow parameters.
- Fixed an issue with changes being lost when using multiplayer.
- Fixed an issue with duplicate calls to delete plugins in multiplayer context.
- Fixed OAuth authentication flow not working for resources in modules embedded within apps.
- Fixed AWS4 authentication by stripping Datadog trace headers before request signing.
- Fixed an issue in Secrets Manager where HashiCorp Vault secret lookups may fail when the lookup occurs very near to the access token expiration time.
- Fixed crash on login/signup page when Assist prompt contains special characters.
- Fixed flickering in code editor autocomplete chips in Safari.
- Fixed token consumption calculation for Assist thread summarization and enabled it by default.
- Fixed an issue with missing AI provider resource types on the v2 Public API.
- Fixed role permission checks incorrectly restricting to Enterprise plans only.
- Fixed Hide native app banners setting incorrectly available to non-Enterprise plans.
- Fixed external users group not displaying correctly as locked in the new RBAC Groups list page.
- Fixed Assist prompt input remounting when available resources change.
improved
- Improved Assist warnings when AI Provider resources are enabled.
- Improved AI settings and Assist updates to prevent inconsistent states.
- Improved workflow execution performance by using compressed block result sizes when determining whether to truncate large results exceeding 10MB.
- Improved copy within functions to use "function" instead of "query".
security-fix
- Updated Java library to fix CVE-2025-48924.
Self-hosted Retool 3.335
No longer supported
Patch release notes
Feb 5, 2026
added
- Added Microsoft SQL Server resource version 3.0 with mssql driver 12.2.0 as the default for new resources.
- Added
focus()method to HTML component to programmatically set focus to the first focusable element. - Added an AI setting that enables organization admins to toggle whether the Assist prompt box appears on the apps landing page.
fixed
- Fixed error messages when Ask AI encounters deleted or misconfigured AI provider resources.
- Fixed an issue where Assist incorrectly indicated event handlers were added to buttons when they were not.
- Fixed query
isFetchingstate not updating correctly when the same query is triggered multiple times concurrently. - Fixed code panel automatically reopening when switching between pages in multipage apps.
improved
- Improved visual alignment by top-aligning toggle switches in AI Settings.
- Improved workflow run context to include release name information for current, last, and last successful runs.
changed
- Changed multi-instance releases to be enabled by default for apps and workflows protected by Source Control.
- Changed custom domain setup to reference CNAME records instead of A records for DNS configuration.
- Changed the Graph pane in Component and Code tree tabs to collapse by default.
- Changed resource permissions to require appropriate access levels beyond Use permission to view connection details.
- Performance Monitoring and Session Replay features are now restricted based on plan and feature availability.
security-fix
- Upgraded lodash library in workflow code blocks from version 4.17.21 to 4.17.23.
Self-hosted Retool 3.330
No longer supported
Patch release notes
Jan 28, 2026
added
- Added support for
excludedAttributes=membersquery parameter in SCIMGet GroupAPI to improve compatibility with SSO providers like Entra ID. - Added Assignment tab to group pages for RBAC management.
fixed
- Fixed AWS knowledge base vector queries failing with "AWS region is missing" error.
- Fixed an issue in Signature component when global orientation was not set as default.
- Fixed issue in Query Library where users were unable to add a new resource from the resource picker.
- Fixed navigation to shortlinked apps in presentation mode loading incorrect cached app.
- Fixed drag-and-drop issue with top folder drop zone.
- Fixed folder order when changing scope during drag operations.
- Fixed edit modal from resource dropdown appearing behind workflow canvas.
- Fixed transaction handling in workflow template conversion.
- Fixed Save button not appearing when adding or removing members from groups as admin or group admin.
- Improved error message when attempting to rename protected apps.
- Fixed missing environment variable for Java database connector.
improved
- Improved Assist page switching behavior by disabling navigation while actively generating to prevent conflicts.
- Added visual indicator when page switching is disabled during Assist generation.
- Improved folder ordering behavior in multiplayer editing.
- Enabled plugin ordering synchronization in multiplayer.
changed
- Changed terminology from "private beta" to "closed beta" in API endpoints.
security-fix
- Fixed XSS vulnerability in REST API custom authentication by adding validation for custom auth URLs.
Self-hosted Retool 3.324
No longer supported
Patch release notes
Jan 14, 2026
added
- Enabled the Tavily resource type for all eligible customers.
- Added support for YAML format OpenAPI specifications in OpenAPI resources.
- Added ca-west-1 as a region option for AWS resources.
- Added authorization code grant with PKCE as an OAuth 2.0 option for Snowflake resources.
fixed
- Fixed a bug that caused Secrets Manager secrets in resources not to work in public apps without a logged-in user.
- Fixed mobile video aspect ratio to be dynamic based on the source video dimensions.
- Fixed Scanner component to no longer add an extra leading zero when scanning UPC-A barcodes.
- Fixed an issue that prevented the camera from switching between front and back when using the WebView component in Retool Mobile.
- Fixed layout issue for HTML elements with data-click-target attribute.
- Fixed an issue where the module input window displays a JavaScript error under certain conditions.
- Fixed an issue that caused an error when connecting to Snowflake via OAuth. Retool no longer sends the parameter
prompt. This extension to the OAuth protocol is not supported by Snowflake, and was ignored in the past, but now Snowflake treats it as an error. - Fixed custom groups being unarchived on plan upgrade.
- Fixed an issue where offline jobs would incorrectly parse request bodies as JSON when using non-JSON content types.
improved
- Improved component tooltips to be hoverable so end users can follow Markdown links and copy text to their clipboard.
- Improved resource Usage tab to display a trash badge for apps and workflows in trash folders.
- Improved app transition feedback with loading indicator when using Go to app or
utils.openApp. - Improved view mode performance by caching app data with service worker.
- Improved code tree display consistency between single page and multipage apps.
- Improved AWS Bedrock resource with updated AI21 Labs and Stability AI models.
changed
- Changed Snowflake Node SDK to use version 2.2.0.
security-fix
- Upgraded jsPDF library to version 4.0.0 to address CVE-2025-68428.
Self-hosted Retool 3.323
No longer supported
Patch release notes
Jan 6, 2026
added
- Added an accessible focus state for Image components with a click handler.
- Added a
folder_idfield to public API endpoints forGET /resourcesandGET /resources/:resourceId. - Added support for OpenAPI ParameterGroup editor for editing JSON objects in Guided REST mode.
- Added support for returning a list of groups when requested from the
GET /user_invitesendpoint. - Added an Assist section to the list of keyboard shortcuts, and added two new shortcuts:
Switch to Ask modeandSwitch to Build mode.
fixed
- Fixed an issue where workflows libraries
requirements.txtshowed deleted library. - Fixed an issue where the Re-auth button did not show for resource query tools in the agents tool creation canvas.
- Fixed an issue in workflows where function parameters were not evaluated for a duplicated function.
- Fixed an issue where granted permissions per resource for query authoring were not applied to auto-fixing queries.
- Fixed an issue with string interpolation in OpenAPI query blocks in workflows.
- Fixed an issue where long JavaScript query blocks in workflows caused a bug with scrolling.
- Fixed an issue that caused an error when connecting to Snowflake via OAuth. Retool no longer sends the parameter
prompt. This extension to the OAuth protocol is not supported by Snowflake, and was ignored in the past, but now Snowflake treats it as an error. - Fixed an issue where Assist users saw an error when using Ask mode and generating apps from scratch with no resources configured in their organization.
improved
- Improved custom component library editing in multiplayer mode for increased reliability.
changed
- Changed behavior for Assist to show a loading spinner when Assist is about to execute an auto-submitted prompt.
removed
- Removed the 'Require is not defined' lint warning in JavaScript code editor.
- Removed OAuth access tokens and non-sensitive ID tokens from audit logs.
Self-hosted Retool 3.320
No longer supported
Patch release notes
Dec 17, 2025
added
- Added optional pagination to GET /accessTokens.
- Added optional pagination to GET /user_requests.
- Added a new GET /deployments API endpoint to list source control deployments. Adds additional response body fields to the existing get deployment and trigger deployment endpoints.
- Added support for a Trigger authentication on every query option for GraphQL resources.
- Added a list of groups the user is in to the GET /user API endpoint.
- Added the ability for Assist to reference URL parameters when writing queries, transformers, and embedded expressions.
- Fixed an issue in the SCIM API that prevented modification of default groups.
- Added support for additional permissions on business plans.
fixed
- Fixed an issue with the UI in the event handler editor.
- Fixed an issue where users needed to be admins to have access to source control. Users just need manage access.
- Fixed an issue that could cause the OAuth callback URL to be incorrect when using Share credentials between users for a resource.
- Fixed an issue with Chart rendering when nested in Stacks.
improved
- Improved query handling logic for mobile apps to defer UI feedback until offline jobs actually run online. Added the Completed section back to the Offline Job Manager screen.
security-fix
- Changed behavior so that the HTTP path field in the Databricks resource now sanitizes semicolons to prevent JDBC parameter injection. If you were previously including connection parameters in the HTTP path (e.g.,
/sql/1.0/warehouses/abc;parameter=value), these will now be stripped. Use the dedicated connection parameters field instead.
Self-hosted Retool 3.317
No longer supported
Patch release notes
Dec 10, 2025
added
- Added client credentials authentication for Databricks.
- Added search bar to Roles and Permissions page.
- Added a new native video component for mobile apps.
- Added new Secrets Manager scoped secrets behavior: if the
SCOPED_SECRETSenvironment variable is true, then secrets whose names begin withscoped--resources--$FOLDER_NAME--can only be used in resources within the specified folder. - Added support for pagination on the public API GET /groups method.
- Added support for pagination on the public API GET /folders method.
- Added support for pagination on the public API GET /spaces method.
- Added support for pagination on the public API GET /apps method.
- Added bearer token authentication to MCP resources for use in Agents.
- Added the ability to add and revoke screen access for groups with the API.
- Added support for encoding user email in the Intercom JWT payload for improved authentication.
- Added optional pagination to GET /user_invites for the public API.
- Added optional pagination to GET /environments for the public API.
- Added support for Assist to create forms outside of modals, when the form is the primary purpose of a page.
fixed
- Fixed autocomplete in resource fields to not show "secrets" as a global object if Secrets Manager is not enabled.
- Fixed an issue with merging branches in multiplayer.
- Fixed an issue where containers on Android devices get a vertical empty space.
- Fixed an issue that allowed permission group creation on Free and Team plans.
- Fixed unsandboxed execution, which now reads max CPU/memory limits exclusively from env vars.
- Fixed
baseDomainshown in source control deployment email alerts. - Fixed a visual bug in column text colors.
- Fixed an issue so that when the
SCOPED_SECRETSenv var is enabled, autocompletion for template strings in resources will filter the secrets to omit any scoped secrets that are not available for that resource. - Fixed an issue where reset password confirmation emails would still be sent to users even when reset password emails are disabled in an organization.
- Fixed an issue where Assist would incorrectly think it could not perform some tasks.
- Fixed an issue that could cause the OAuth callback URL to be incorrect when using Share credentials between users for a resource.
improved
- Improved GUI query behavior.
- Improved PDF rotation in the PDF viewer component in Mobile to use native rotation support for smoother performance. Fixed an issue where very large PDFs in Mobile could cause memory issues. Improved page navigation in the PDF viewer component in Mobile to use native page navigation methods for more reliable page transitions.
- Improved accessibility when setting up two-factor authentication.
- Improved the way that Assist troubleshoots issues.
- Improved UI of the OpenAPI resource editor.
- Improved Assist's understanding of how to use the tools available to it.
changed
- Changed Assist behavior so that when the default models are selected, Retool attempts to use the Anthropic resource for Anthropic requests, and sends requests to Anthropic through Amazon Bedrock as a fallback.
- Changed protected trigger feature to be generally available.
- Changed behavior so that if the
SCOPED_SECRETSenv var is set, secrets with scoped names are shown separately in the Secrets Manager list.
removed
- Removed resizability of the Description field of a role if the description itself cannot be edited.
- Removed sensitive user tokens from audit logs with OAuth2 SSO.
Self-hosted Retool 3.312
No longer supported
Patch release notes
Dec 3, 2025
added
- Adds a shadow style property and basic organization-level theming support for Alert v2.
- Added spell check support to editable string cells in Table and Key Value components.
- Added support for GPT-5.1.
- Added a shadow style property to the Image component.
- Added
initialDeeplinkobject to the Retool mobile app model for accessing URL parameters and screen navigation information when an app is opened via a deep link. - Added the
ariaLabelproperty to Link components. - Added availability for editing "Roles and permissions" to the Business plan.
- Added a shadow style property to the ImageGrid component.
- Added the
gemini-3-pro-previewmodel for use in Retool AI. - Added an additional permissions banner to the Groups page.
- Added support for creating release artifacts of protected workflows from the configured default branch.
- Added a search option to the Groups page.
fixed
- Fixed an issue with HTML sanitization in the "Failed workflow" alert emails.
- Custom component edits in apps will sync more consistently for multiple editors.
- Fixed an issue where queries containing the word "select" may return an error.
- Fixed an issue with the State tab.
- Fixed an issue with scrolling in the Roles page.
- Fixed an issue where Assist may remove existing column configuration properties that it doesn't support whenever it edits any table column.
- Fixed an issue where the navigation header may flash during redirect.
- Fixed an issue with multi-instance releases so users can protect an element, create a release artifact, and update the manifest in the same PR.
- Fixed an issue where an agent may attempt to continue, before a child agent, invoked as a tool, has finished.
- Fixed an issue where the Source Control branch menu may not load correctly.
- Fixed an issue where Code Executor does not support the
LOG_LEVELenvironment variable. - Fixed an issue that prevented the Retool API from creating folders without passing in
parent_folder_id.
improved
- Exposed font names in the Theme object.
- Improved the performance of Assist-generated UI changes to large apps.
- Improved Assist's ability to write event handler scripts.
- Improved accuracy of custom component library dev modes.
- Adds pagination parameters to the
getUsersRetool API endpoint. - Improved component icon handling for Assist.
changed
- Renamed the OpenAI resource to OpenAI Platform.
Self-hosted Retool 3.307
No longer supported
Patch release notes
Nov 20, 2025
added
- Adds a notification banner to Assist chat threads for token consumption awareness.
- Added
RESOURCE_TYPES_DENY_LIST_CREATE_ONLYenv-var, which prevents users from creating new resources of specific types, but does not block queries the wayRESOURCE_TYPES_DENY_LISTdoes. - Added the trigger type to workflowContext.
- Added permission guards for resource access via Assist.
- Added sorting options to list of spaces in the Spaces settings. Defaults to alphabetical sorting based on space names.
- Added support for Google Slides resources.
- Added support for
isEditorModetoQUERY_RUNaudit trail log events.
fixed
- Fixes UI issue for thinking box states.
- Fixed non-admin users ability to see the External Users group and any groups they are an admin of in Settings if they are group admins and have external Retool manage scope.
- Fixed an issue with Retool header flashing on redirect to a workspace.
- Fixed an issue with REST API resources where the
metadata.requestproperties may not always be correctly sanitized. - Fixed an issue with OpenAPI resources where the
metadata.requestproperties may not always be correctly sanitized. - Fixed an issue with GraphQL resources where the
metadata.requestproperties may not always be correctly sanitized. - Fixed issues where Assist failed to add components to header frames.
improved
- Improved the speed and quality of Assist edits on existing UI layouts.
- Improved the hint when there's existing messages in the thread in the Assist input text box.
removed
- Removed user access to app modules in other app pages if they only have access to a specific page, not the entire app.
- Removed expiry warning banners during signup and guided-tour.
Self-hosted Retool 3.303
No longer supported
Patch release notes
Nov 13, 2025
added
- Added Google Slides tools to Retool Agents.
- Added support for Azure OpenAI as a single model provider for Assist.
- Added support for Google Search grounding in Gemini for Retool AI. You can enable this option in the organizaton's Beta settings.
- Added the
RESOURCE_TYPES_DENY_LISTenvironment variable to prevent users from creating and running against the provided resource types.
fixed
- Fix an incorrect documentation link for the Event List component.
- Fixed an issue when opening an app in the IDE using the
historyOffsetURL parameter. - Fixed an issue with placeholders in the Key Value component.
- Fixed an issue where tooltips may not appear in the App IDE code editor.
- Fixed an issue with renaming modules.
improved
- Assist can now verify the configuration of AI models and display an error if verification fails.
- Improved the layout of the Workflows tab.
- Improved visibility of errors when protected apps reference unprotected modules.
- Improved error reporting within single-model providers to show model-specific information.
changed
- Updated the app Share modal.
- Changed the Login Retool Event to be enabled by default.
- Changed references of AWS Bedrock to Amazon Bedrock.
- User profile pictures now appear when viewing group members.
security-fix
- Patched a security issue related to auto-join domains.
Self-hosted Retool 3.300
No longer supported
Patch release notes
Nov 5, 2025
added
- Added a call to action in all single-page apps that prompts users to migrate to multipage.
- Added web grounding support for Google Gemini models, allowing them to search the web for up-to-date information when answering queries.
- Added new beta features for Secrets Manager in on-premise instances, allowing multiple Secrets Manager configurations to be used at once (to get secrets from different providers, or from different areas within the same provider).
- Added a CTA to the homepage announcing Assist.
- Added an option to exclude Table columns from search.
- Added toggling the Assist tab as an option in the command palette.
- Added OpenAPI/Swagger spec support to REST API resources, enabling structured API queries with autocompletion of endpoints and properties.
- Added more detailed response messages for insufficient user permissions when editing Agents.
- Added an empty object default for the
GET /resource_configurationsAPI endpoint. - Added one-click removal of roles from Groups.
- Added a
.focus()method for Container components. - Added a new, dismissable Assist call to action to the Add Component tab.
fixed
- Fixed an issue that prevented the default credential provider from being utilized by SQS and SNS resources.
- Fixed formatting of dynamic columns in Tables to apply to columns with an inferred type.
- Fixed the Vault integration in Secrets Manager so that it no longer incorrectly states the connection failed if the list of secrets is empty.
- Fixed an issue with the
enableInstanceValuesproperty of List View children. - Fixed an issue where resource configuration options did not appear for calls to
/resource_configurationsfor gRPC resources. - Fixed an issue where long JavaScript queries in single-step functions were being truncated unexpectedly.
- Fixed a bug that caused a
ReferenceErrorFirebase` raw-mode queries. - Fixed issues with validation in List Views.
- Fixed an issue that prevented SSO buttons from appearing on user invite screens.
- Fixed an issue that caused flickering when scrolling through a group's members list.
- Fixed an issue that prevented a tool from appearing in the UI during agent execution if the tool had a long description (>2000 chars).
- Fixed an issue with cycling through Assist history within an Assist thread using up/down keyboard arrows.
- Fixed an issue that could cause autocomplete in resource editors not to include Secrets Manager secret names.
- Fixed an issue where old MCP resources may be set up with invalid authentication settings when auto-configuring authentication.
- Fixed an issue where non-Enterprise organizations were incorrectly shown an admin granularity banner.
improved
- Improved load times for high-latency connections.
- Improved UI in Secrets Manager settings.
- Improved Assist's ability to work with globally scoped queries and components.
- Improved the information architecture of the Groups settings page and added a separate section to display the group's roles and permissions.
- Improved custom component dev mode fetching to make the component more responsive to backend changes. A toast now appears to show when a refresh is underway.
- Improved the resource description field to expand automatically as you type.
changed
- Changed Kafka, SQS, SNS, and Tavily Web Search integrations from beta to general availability.
- Changed a rule so that non-admins (with proper role) can provide tokens to create custom components.
- Changed per-screen permissions to be enabled by default for Enterprise customers.
deprecated
- Deprecated OpenAI's GPT-3.5-turbo-instruct model in favor of GPT-4.0-mini.
- Deprecated Claude 3.5 Sonnet in favor of Claude Sonnet 4.5.
Self-hosted Retool 3.295
No longer supported
Patch release notes
Oct 29, 2025
added
- Added options to select either Amazon Bedrock, OpenAI, or Anthropic as the single-model provider for Assist.
- Added the
RESOURCE_TYPES_DENY_LISTenvironment variable to prevent users from creating and running against the provided resource types. - Added the
RTEL_SEND_TO_RETOOL_INPUT_ALLOWLISTenvironment variable to specify which data to send to Retool's telemetry server. - Added
cmd+ias a new keyboard shortcut to toggle the Assist panel open or closed.
fixed
- Fixed a scrolling issue with the canvas.
- Fixed an issue where OpenAPI responses had data left out. This data is now encoded as Base64.
- Fixed an issue that could delay a Secrets Manager update for several minutes after a configuration change.
- Fixed an issue with multi-spec OpenAPI resources.
- Fixed a bug in the public API when deleting workflow folders and added support for creating, updating, retrieving, and deleting agent folders.
- Fixed ordered list numbers not showing up when there are many steps in Assist's planned action.
- Fixed an issue with OpenAPI Query Editor for Firefox which wouldn't open the dropdown when a value was already selected.
- Fixed an issue where an error from an MCP server could cause a Retool backend service to crash.
- Fixed an issue where organizations on the Free or Team plan may have limited access to Organization Themes.
improved
- Improved the error message in Assist when proxy authentication issues occur.
- Improved app accessibility by disabling keyboard focus for tooltips.
changed
- Changed workflow overage emails so that they include the organization subdomain.
- Changed the login page text content.
- Updated the menu options for blocks in workflow functions.
- Moved the Close button for workflow functions to the top right.
Self-hosted Retool 3.291
No longer supported
Patch release notes
Oct 22, 2025
added
- Added support for drag-and-drop page reordering.
- Added audit log events for Source Control deployments.
- Added support for managed key AI features when using a HTTP proxy.
- Added permission checks for page cloning.
- Added support for Claude Haiku 4.5.
- Added support for README interactions to Assist.
- Added support to Assist for referencing global objects in Javascript queries and transformers.
- Added automatic app name generation to empty apps when using Assist.
fixed
- Fixed an issue where popups may incorrectly stack on the workflow canvas.
- Fixed an issue where the Create dropdown may include duplicate links.
- Fixed an issue with incorrect access level displaying to external apps on the Users page.
- Fixed an issue with query formatting in workflow blocks.
- Fixed an issue that prevented protected apps from loading correctly.
- Fixed an issue with Assist where navigating to a module prevented the module settings panel from opening.
- Added the Retool AI Vector: Retool AI query writers (edit access) can manage vectors to the Beta settings which allows users with Retool AI edit permission to use create and manage vector documents.
- Fixed an issue where previews for draft mobile apps may not load correctly.
- Fixed an issue with branch merging and collaborative app editing.
- Fixed an issue where Assist may fail and return partially streamed Markdown results.
- Fixed an issue where collaborative editing may not function correctly with protected apps.
- Fixed an issue with skipped releases getting unpublished for users with multi-instance releases and spaces.
- Fixed an issue where apps may incorrectly report an undefined theme.
- Fixed an issue causing workflows using OAuth resources to break inside of nested workflows.
- Fixed an issue where the Query Library would show unclear error messages if proxy authentication was misconfigured.
- Fixed the
aria-labelledbyattribute for the Checkbox Group component. - Fixed an issue with branch cleanup in Source Control.
- Fixed an issue where the App IDE may fail to respond when attempting to edit a module.
improved
- Improved the appearance of Assist autocomplete.
- Improved the accessibility of buttons used for authentication pages.
- Improved granular access permissions so that users can also delete API tokens they've created.
- Improved the layout of Assist property blocks.
- Improved the header style in Assist.
- Improved accessibility experience for two-factor authentication setup.
- Improved Assist's ability to work on globally scoped JavaScript queries.
- Improved the Navigation component by exposing
persistUrlParamsas a property. - Improved app accessibility by disabling keyboard focus for tooltips.
changed
- OAuth resources are now only available when using directly invoked workflows, apps, and agent tool calls.
- Changed apps to use a default width of
100%. This reverts a previous change that made apps1200pxwide by default. - Changed the login page text content.
deprecated
- Deprecated the
llama-4model in the open source AI provider. This has been replaced withkimi-k2-instruct-0905.
Self-hosted Retool 3.286
No longer supported
Patch release notes
Oct 15, 2025
added
- Added a Select all button in the access token creation UI.
- Added a new dialog for users to provide feedback for Assist.
- Added a new API endpoint, Get IP Allowlist By Region, which returns Retool's whitelisted IP addresses.
fixed
- Fixed an issue that prevented workflow owners without access to the trash folder from deleting their workflows.
- Fixed an issue with the Select component's
aria-activedescendantproperty - Fixed incorrect error messages regarding page scope in the editor for Retool Storage queries.
- Fixed an issue where Assist sometimes did not provide a title on Modal frames.
- Fixed an issue with Assist tool call checkmark alignment.
- Fixed a connection error for customers with long running source control deployments.
improved
- Improved the accuracy of the step counter shown in Assist threads.
- Improved the consistency with which Assist is able to correctly populate the options of a Select input.
- Improved the display of status text in Assist.
- Fixed an issue where Assist would unnecessarily disable row selection on Table components.
changed
- Changed ... action menu behavior to disable it and add an explanatory tooltip if there are no actions a user can take. If a single action in a menu is disabled, a tooltip is added upon hover.
- Changed the behavior when a user tries to access a Workflow they don't have permissions for. Now they will be redirected back to the workflows landing page with an error toast.
- Changed all emails from Retool so that they use the most updated Retool logo.
removed
- Remove Last Actions from Assist Tool Call header.
deprecated
- Deprecated the open source
llama-4-maverickAI model in favor ofkimi-k2-instruct-0905.
Self-hosted Retool 3.283
No longer supported
Patch release notes
Oct 7, 2025
fixed
- Fixed a bug that prevented some users from accessing Assist.
improved
- Improved a series of error messages returned by Assist.
Oct 7, 2025
added
- Added capability for admin users to be able to edit and delete Source Control branches created by other users.
- Added support for Claude Sonnet 4.5.
- Added
release_versionto apps-related public API endpoints. - Added support for the Jira v3 API in the Jira resource type.
- Added support for the Assist tab in the App IDE.
fixed
- Fixed inconsistencies in user interface standardization in Retool Database.
- Fixed a bug that caused inconsistent behavior of Etags in the public API for Source Control configuration.
- Fixed an issue that caused idle-in-transaction errors for releases in Source Control deploys.
- Fixed an issue where a Loop block input showed the block ID when positioned after a Branch block. Also fixed an issue that caused a missing dependencies warning not showing in the Loop block.
- Fixed a backend error message related to white-labeled mobile apps to be more clear.
improved
- Improved the agent-worker configuration to be simplified, and eliminate the need for
WORKER_TEMPORAL_TASKQUEUE. - Improved latency.
changed
- Changed permission configuration so that users who do not have permission for an agent, regardless of whether or not they have permission for a workflow, will be unable to see the Agents tab in the navigation bar.
- Changed the default app width to be 1200px wide.
deprecated
- Deprecated Gemini 1.5 models. Gemini 2.0 Flash will be used instead.
Self-hosted Retool 3.280
No longer supported
Patch release notes
Oct 1, 2025
added
- Added organization information to the "Login from new IP address" email to reduce user confusion.
- Added a description for embedded apps.
fixed
- Fixed an issue where autocomplete popup for resource configuration forms showed JavaScript keywords in places where only constants are allowed.
- Fixed an issue where published releases weren't being updated properly in the UI without a refresh.
- Fixed an issue with Anthropic API key handling when using a custom proxy.
- Fixed an issue where modal dialogs would not display properly due to stale component state.
improved
- Improved test interface by disabling the Run all tests button when no tests exist.
- Improved alert styling to enhance icon contrast in light mode.
- Improved test suite management by automatically removing empty test suites when closing without a name.
- Improved the Verify your email message in the Share modal for better user clarity.
Self-hosted Retool 3.276
No longer supported
Patch release notes
Sep 24, 2025
added
- Added
.focus()method for Button components. - Added support for Hashicorp Vault database engine in Secrets Manager. Vault database role names are treated as secret names, and credential properties (such as
usernameandpassword) can be accessed using syntax like{{ secrets.pg.username }}.
Self-hosted Retool 3.275
No longer supported
Patch release notes
Sep 19, 2025
added
- Added the ability to copy the secret key during OTP setup instead of only relying on the QR code.
fixed
- Fixed an issue where toggles in the Retool Database UI were not working in the field visibility popup.
- Fixed an issue where Source Control deployments may fail in rare circumstances.
- Fixed an issue with the Resource dependencies permissions flyout bar.
- Fixed an issue where landing pages may not work correctly for some groups.
improved
- Improved the Retool Database form UI experience.
- Improved accessibility of the Drawer frame by adding the ARIA
dialogrole. - Improved screen reader accessibility of localized content when the locale updates.
- Improved accessibility of the Retool app structure tree.
Self-hosted Retool 3.272
No longer supported
Patch release notes
Sep 17, 2025
added
- Added options to convert empty strings and
NULLvalues to actual null values when importing CSV or Google Sheets data into nullable Retool Database columns. - Added
current_useraccess in function blocks for custom tools in Agents. - Added informational banner for organizations with admin granularity enabled on user, groups, and roles pages.
- Added commit signing option for source control with GitHub.
fixed
- Fixed an issue where CSV and Google Sheets imports incorrectly pre-selected timestamp type for integer columns containing values 1-12.
- Fixed an issue where instrumentation events would have scope errors if they were on the page.
- Fixed typos in the Create Agent template descriptions.
- Fixed accessibility issue with toast notification icons by adding aria roles.
- Fixed an issue causing login loops when signing in with two-factor authentication on Safari.
- Fixed aria-labels for Select and Radio components to improve accessibility.
- Fixed toggles not working in the field visibility popup in Retool Database.
improved
- Improved the target of the SkipLink accessibility feature to focus on main content instead of the header.
- Improved error handling for large imports from Google Sheets into Retool Database.
- Improved error logging in jobs runner by including additional license check errors.
- Improved user interface standardization in Retool Database forms by updating toggle components.
- Improved user interface standardization in Retool Database forms by updating icons and buttons.
- Improved accessibility by adding aria-labels to modal containers.
- Improved keyboard focus management when opening and closing Modal and Drawer components.
changed
- Changed the internationalization feature to general availability.
Self-hosted Retool 3.268
No longer supported
Patch release notes
Sep 10, 2025
added
- Added a
-vverbose option to the Custom Component Library.
fixed
- Fixed an issue where Source Control may not function correctly with Azure Repos if Use Basic Auth is enabled.
improved
- Improved the experience of selecting multiple apps.
- Improved workflows code block testing latency.
- Improved the behavior of Source Control to prevent files or other elements having the same name as a Toolscript folder.
Self-hosted Retool 3.267
No longer supported
Patch release notes
Sep 5, 2025
added
- Added tooltip to workflow name on the index page to increase visibility of long names.
fixed
- Fixed an issue where module inputs failed to load.
- Fixed an issue where
current_user.groupsmay not be evaluated in resource queries. - Fixed a bug in Google Cloud Storage connector that could make downloads fail.
- Fixed a bug that prevented configuring a foreign key that references an autoincrement integer column.
- Fixed flashing navigation bar when redirecting to landing page.
- Fixed an issue with Retool Storage Next Page and Previous Page links that caused them to open content in a new tab.
improved
- Improved the max iterations error message in Agents to direct users to advanced settings.
changed
- Parent window communication in embedded apps is now generally available, and configuring a setting is no longer required.
security-fix
- Patched a security vulnerability that could cause environment variables to be printed during code-executor startup.
Self-hosted Retool 3.259
No longer supported
Patch release notes
Sep 3, 2025
fixed
- Fixed an issue where module inputs would not load.
security-fix
- Patched a security vulnerability that could cause environment variables to be printed during code-executor startup.
Aug 27, 2025
added
- Added a new organization setting to restrict Retool Storage file access for users with Use permissions to only files they uploaded.
fixed
- Fixed an issue where the temperature setting was incorrectly shown for GPT-5 model selection in AI queries.
- Fixed an issue where an email verification error was incorrectly displayed when sharing a public app.
- Fixed an issue with the Workflow Outline component display and overflow handling.
Self-hosted Retool 3.256
No longer supported
Patch release notes
Aug 20, 2025
added
- Added configuration variable changes to audit log.
- Added endpoints for multi-instance release manifests.
- Added support for using secrets in headers when using a custom AI provider.
- Added organization-level setting to restrict users to only view their own files in Retool Storage.
fixed
- Fixed an issue that prevented the top navigation bar from showing when redirecting to a landing page.
- Fixed an issue with dependent permissions for resources.
- Fixed an issue where the Used by tooltip may not be visible.
- Fixed an issue where cookie failures could be ignored.
- Fixed an issue with the Notion resource where it may fail to perform requests relating to pages.
improved
- Improved accessibility on 2FA confirmation page.
- Improved resource information when importing and exporting workflows across deployment instances.
- Improved preloaded CSS settings to clarify usage.
- Improved workflow error messages by including the name of a resource if it's not configured in the current environment.
- Improved Navigation component accessibility by implementing the Roving tabindex best practice.
- Improved the appearance of workflow outlines.
changed
- Changed the default permissions for All users when creating a new organization on the Business or Enterprise plans. This group now has no permissions by default and can be updated as needed. This does not affect existing organizations.
deprecated
- Deprecated support for YAML in Source Control. Upgrade to Toolscript in Settings > Source Control to avoid disruption.
Self-hosted Retool 3.250
No longer supported
Patch release notes
Aug 13, 2025
added
- Added support for Databricks Lakebase connector, which allows connections to Databricks Lakebase instances using a PostgreSQL protocol.
- Added OAuth 2.0 authentication support for Databricks Lakebase connectors.
- Added a
hostconfiguration option for Snowflake proxy connections. - Added token-based authentication as an option for Bitbucket repositories.
fixed
- Fixed an issue in the multiplayer feature where renaming a page in one tab caused page folders to disappear in another tab.
improved
- Improved performance for multipage apps by optimizing dependency graph calculations.
changed
- Removed VM2 dependency. Running workflows and Firebase Raw mode queries now require the Code Executor service to be deployed to work properly.
Self-hosted Retool 3.248
No longer supported
Patch release notes
Aug 6, 2025
added
- Added a Trash folder display in the workflows UI with move to trash functionality.
- Added support for using API tokens from parent admin organizations to create external users.
fixed
- Fixed an issue where external settings were incorrectly hidden from admin users.
- Fixed an issue with SCIM when deactivating users with some providers like Microsoft Entra.
- Fixed an error when viewing the access list for some resources.
- Fixed an issue where
retoolContext.pageswasn't updating when another user added a new page in multiplayer multipage apps.
changed
- Changed public app creation to require verified email addresses.
Self-hosted Retool 3.244
No longer supported
Patch release notes
Jul 30, 2025
fixed
- Fixed an issue where users could create new apps and workflows from the home page despite Source Control being locked to prevent changes.
- Fixed an issue with folder interactions when multiple users are editing an app.
- Fixed an issue where a DELETE API call to remove a disabled user from a group would silently fail.
- Fixed an issue where the External settings tab may not be visible.
security-fix
- Patched a security vulnerability in the
node-bitbucketlibrary that could expose authentication details in error responses.
Self-hosted Retool 3.243
No longer supported
Patch release notes
Jul 24, 2025
fixed
- Bug fixes and improvements.
Self-hosted Retool 3.242
No longer supported
Patch release notes
Jul 24, 2025
added
- Added special footer for emails sent by Agents.
- Added ability for admin users to delete elements (apps, workflows, resources, queries, themes) when Source Control is on.
- Added UI changes to allow admin users to delete elements even when
VERSION_CONTROL_LOCKEDis set to true.
fixed
- Fixed an issue with
new moment()usage support in JavaScript code.
improved
- Improved module layout by adding height and overflow configuration options.
- Improved API documentation by correcting the Retool version information for access lists with types resources, workflows, and agents.
deprecated
- Deprecated old Anthropic models and mapped them to Claude 3 Haiku.
Self-hosted Retool 3.240
No longer supported
Patch release notes
Jul 23, 2025
added
- Added support for Gemini 2.5 Flash stable model.
- Added streaming support for the self-hosted managed key proxy.
- Added support for AWS Secrets Manager integration to use EKS Pod Identity Associations for authentication.
- Added Retool AI to role permissions.
fixed
- Fixed an issue where
moment.tz.names()and other static method access of sub-namespace function objects in moment were not working correctly. - Fixed an issue causing intermittent failure when protecting query library queries that use a resource with multiple environments.
- Fixed broken documentation links for resource types in queries.
- Fixed an issue causing an infinite toast loop when renaming a workflow.
- Fixed an issue where MongoDB resources could not override the default
authMechanism.
improved
- Improved error messaging for invalid Retool Storage queries where there is a slash in the folder name.
changed
- Changed MySQL resources to use the improved MySQL Connector by default. Changed Databricks resources to consistently use the Java DB connector for better performance and reliability. V1 Connectors for MySQL and Databricks are deprecated and cannot be used anymore.
Self-hosted Retool 3.236
No longer supported
Patch release notes
Jul 16, 2025
added
- Added support for OpenAI's gpt-image-1 model for image generation.
- Added
USAGE_API_TOKEN_FILEto the list of environment variables that can be loaded from the file system withRETOOL_LOAD_FILE_SECRETS. - Added API and UI support for access lists for resources, workflows, and agents.
fixed
- Fixed an issue where resources synced from source control would not inherit permissions from their parent folder.
- Fixed an issue where the UI crashed instead of showing an upgrade banner when self-hosted customers reached their maximum seat limit on Team and Business plans.
- Fixed an issue with variable substitution on Kafka queries.
improved
- Improved overflow handling for long email addresses in usage analytics Top viewers list.
Self-hosted Retool 3.234
No longer supported
Patch release notes
Jul 10, 2025
added
- Added OAuth 2.0 authentication support for the Databricks resource. Previously, this option was only available to certain organizations.
- Added Include "Sent via Retool Email" signature checkbox to Retool Email queries. For Free and Team organizations, this is always checked. For Business and Enterprise organizations, unchecking removes the signature.
- Added GUI Mode to the Agent Resource Query for easier invoking and progress checking of agent runs from workflows and apps when not using the Agent Chat component.
- Added resource name filtering for audit logs.
- Added audit log links in app and query menus.
- Added
idpProvisionedfield to audit log metadata. - Added a security measure that prevents HTTP-based resources from accessing localhost, unless bypassed via either the
ALLOW_PUBLIC_API_LOCAL_HTTP_REQUESTSorALLOW_LESS_SECURE_LOCAL_HTTP_REQUESTSenvironment variable. - Added
AGENTS_ENABLEDenvironment variable.
fixed
- Fixed an issue where disabled options in the Multiselect component could be removed when selected.
- Fixed an issue where Retool would display a "Validation error" when a user logged in with SSO OIDC and certain group mapping conditions applied.
- Fixed an issue where queries would break when using
moment()with array iteration.
improved
- Improved style editors that support CSS length values with minor enhancements.
- Improved the
HIDE_PROD_AND_STAGING_TOGGLESenvironment variable to also hide resource environment toggles in workflows and resource configuration UIs, disable editing existing resource environments, and display an explanatory banner on the Environments settings page. - Improved output preview UI.
- Improved test case editing in side panel.
changed
- Changed workflow permissions to now require owner permissions.
- Changed "Preview" button text to "Test".
Self-hosted Retool 3.227
No longer supported
Patch release notes
Jun 27, 2025
fixed
- Fixed an issue with apps currently being edited by multiple users where cursors weren't showing on page but would show after switching pages.
- Fixed an issue where Table column option lists would not properly update if they reference
currentRoworcurrentSourceRow.
changed
- Removed GUI Mode from the Agent Resource Query configuration.
Self-hosted Retool 3.224
No longer supported
Patch release notes
Jun 25, 2025
fixed
- Fixed an issue where the documentation link for the Libraries tab in Settings was incorrect.
- Fixed Self-hosted Retool committed customers' ability to receive monthly free hours of Agents usage.
improved
- Improved the OpenAPI resource form to display supported versions information.
- Improved styling on the Output container for query runs.
- Improved component documentation links to component guides instead of component references where available.
security-fix
- Patched a security vulnerability in the passwordless login system.
Self-hosted Retool 3.223
No longer supported
Patch release notes
Jun 17, 2025
added
- Added
nowIndicatorsupport to the Calendar component. - Added page number UI to the PDF viewer component.
- Added an affordance for suppressing page navigation during app testing recording.
- Added the ability to toggle between JSON and Table formats when viewing query results.
- Added support for AWS IAM Auth to authenticate with Retool's primary application database.
- Added a Modules tab to the Add component popover.
fixed
- Fixed an issue where an authentication error may be saved in the query result cache.
- Fixed an issue where blurring a Select input would not clear the search term.
- Fixed an issue where blurring a Multiselect input would not clear the search term.
- Fixed an issue where the Allow others to join the organization checkbox was incorrectly saved during the creation of an organization.
- Fixed an issue where you could not set the view of a Tabbed Container from a module.
- Fixed an issue where SQS or Kafka workflows did not run as expected.
- Fixed an issue where module query folders were incorrectly added to the parent app when updating preloaded JavaScript.
- Fixed an issue where the
runFunctionblock displayed the wrong icon. - Fixed an issue where module input names were not truncated.
- Fixed several bugs with module input popovers, including value resets and popover behavior.
changed
- Updated Retool API to use the OpenAPI 3.0.4 spec.
removed
- Removed the Disable Multiplayer toggle from the app settings menu.
- Removed the Disable Multiplayer toggle from the app settings menu.
- Removed the Connect resource button from demo resource queries.
Self-hosted Retool 3.219
No longer supported
Patch release notes
Jun 11, 2025
added
- Added query execution plan preview functionality for PostgreSQL databases.
fixed
- Fixed an issue where rate limit errors could occur when using custom AI providers.
- Fixed an issue where the calendar overlay would show in read-only date/time components.
- Fixed an issue where an authentication error may be saved in the query result cache.
- Fixed a minor UI bug where access lists could display a user count in their headers that included inactive users.
- Fixed an issue where a scrollbar would incorrectly appear for the Access List modal for apps.
- Fixed frame height jumping in certain cases.
- Fixed automatic text color contrast for header cells in the Table component.
- Fixed an issue where the save button could be pushed off screen by a long group name.
- Fixed an issue where the enumLabels property did not work for custom components.
- Fixed an issue where Cell Click events for link columns in the Table component would trigger when clicking anywhere in the cell.
- Fixed an issue where a validation error was not shown when users set
'id'as module input name.
improved
- Improved the Postgres connector to return preview data for read-only queries, aiding inspection.
Self-hosted Retool 3.215
No longer supported
Patch release notes
Jun 4, 2025
added
- Added
DBCONNECTOR_GUI_MODE_POOL_MIN_SIZEandDBCONNECTOR_GUI_MODE_POOL_MAX_SIZEenvironment variables for tuning database connection behavior for GUI mode queries. - Added header background and text colors as column properties for the Table component.
- Added audit log coverage for permission changes to apps and workflows for a permission group.
- Added audit log coverage for permission changes to folders and resource folders for a permission group.
- Added audit log coverage for changes to universal access levels on objects and for additional permission updates.
- Added audit log coverage for changes in the folder locations of resources and workflows.
fixed
- Fixed an issue where an error message would appear when setting a module output's value to a non-string.
- Fixed a race condition that would occasionally cause the initial render of custom components to use stale data.
- Fixed an issue where controls in Retool Forms editors would not have the correct colors when using a custom theme.
improved
- Improved reset password error and success messages by moving them to inline alerts for better visibility.
- Added environment scope check to allow non-admin users with
environments:managepermission to access environment settings. - Improved Source Control branch management by adding hotfix branch filtering when viewing all branches.
- Added observability scope check to allow non-admin users with
observability:managepermission to edit observability settings. - Added a scope check to Retool API to allow non-admin users with
retool_api:managepermission to edit Retool API settings. - Improved permission handling of public pages.
- Improved permission handling of Source Control endpoints.
- Improved execution of workflows with the 'function' triggerType.
- Improved descriptions for migration commits for better clarity.
- Improved the OpenAPI resource integration to support text responses similar to REST API resources.
changed
- Changed the default access permission when creating Google Sheets resources to read only.
- Changed SQL editor behavior by removing ambiguous preview functionality to prevent accidental query execution.
Self-hosted Retool 3.212
No longer supported
Patch release notes
May 29, 2025
added
- Added a banner when the workflow doesn't include a response block.
fixed
- Fixed an issue with user attributes scope.
- Fixed an issue where Tavily resources may not correctly save API key settings.
- Fixed an issue where URL params in single-page apps were not type casting directly.
Self-hosted Retool 3.207
No longer supported
Patch release notes
May 19, 2025
added
- Added a visual indicator (dashed line) to the Table component's column headers with tooltips.
- Added support for wrapping column header text to the Table component.
fixed
- Fixed an issue where custom CSS was not preserved when converting an app to multipage.
- Fixed an issue with text overflow for property values and parameters.
- Fixed an issue where Select components would not display the option list correctly on mobile browsers.
- Fixed an issue that prevented restoring an older version of an app from the History tab.
- Fixed an issue that would cause data streaming functionality to fail.
- Fixed an issue where icons were not displaying properly.
improved
- Improved List Objects API to support
include_inherited_accessfor apps.
changed
- Changed access restrictions for public apps in use by organizations that downgraded.
Self-hosted Retool 3.203
No longer supported
Patch release notes
May 14, 2025
added
- Added the
operation'attribute to Datadog performance traces. - Added the
appUuidandtraceTypetags to all performance monitoring spans. - Added support for creating an app and release in the same deployment for multi-instance releases beta users.
- Added an option to send email replies directly using SMTP and default Retool Email resources.
- Added an icon next to certain app releases indicating that they are managed via source control.
fixed
- Fixed an issue that allowed apps to be overwritten with stale data.
- Fixed an incorrect string in user settings referring to embed users as
external.
improved
- Improved the navigation to selected table when clicking on Retool DB resource link in Forms editor.
- Improved resizing support on the source control deployments page.
- Improved the radio button for permission group selection for consistent UI experience across access type selectors.
Self-hosted Retool 3.200
No longer supported
Patch release notes
May 7, 2025
added
- Added
access_levelto the list of properties returned by theGet user apps and foldersuser action resource query.
fixed
- Fixed an issue where a custom app theme remained after user clicked
Hide allandShow allon form. - Fixed an issue where alerts would appear in the Run panel of the Workflow IDE too frequently.
- Fixed an issue with the default AI model dropdown if no provider was enabled and no previous model was selected.
- Fixed an issue where URL hash parameters did not persist across Source Control branching actions.
- Fixed an issue where resetting a Source Control repository branch may fail.
improved
- Select and Radio Group components now support label wrapping.
changed
- Upgraded CircleCI API dependencies.
Self-hosted Retool 3.196
No longer supported
Patch release notes
Apr 30, 2025
added
- Added a waitlist callout for AI-generated app functionality on the Apps page.
- Added a configurable decimal places option for number inputs in Retool Forms
- Added the App Inspector.
fixed
- Fixed an issue with an error message in the workflow run panel.
- Fixed model dropdown for image generation when calling Retool AI.
- Fixed a bug with the in-progress checkbox filter in the workflow run panel.
- Fixed various issues with the workflow run panel filters.
improved
- Improved the tooltip description for the database column index lightning bolt.
- Improved the
Used inlist for modules to include nested usage with a new[Nested]tag. - Improved export to module functionality.
- Improved the UI for path params and test headers.
- Improved the error message for asynchronous webhook-triggered workflow timeouts.
changed
- Changed the undo functionality to limit it to the last 20 operations.
- Changed wording for
use as example JSONbutton - Changed component positioning information in ToolScript to be organized by per-page.
removed
- Removed quick actions for module containers.
deprecated
- Deprecated YAML serialization for apps and resources.
security-fix
- Fixes a security issue by sanitizing the auth header in Bitbucket error logs. Relevant for users with Bitbucket as their source control provider.
Self-hosted Retool 3.191
No longer supported
Patch release notes
Apr 23, 2025
added
- Added Code Executor Health Check in Settings for on-premises deployments.
- Added
runFunctionitem to subflow Add block menu. - Added search functionality for admins within their list of configuration variables.
- Added the latest API updates to the Stripe resource type.
fixed
- Fixed various issues for the Retool Workflows Run history panel.
- Fixed preview links in source control PRs for protected and unprotected applications.
- Fixed an issue with Snowflake resources where dynamic database and warehouse names did not work correctly.
- Fixed a bug related to new functionality introduced in v1.7.3 of the CLI.
- Fixed a minor visual issue on the Retool home page where hovering over a protected app misaligned the dropdown menu.
improved
- Improved visibility of setup errors in JavaScript blocks.
- Improved resource permission error messages by adding the resource
sdisplayName`. - Improved the Custom Component Library CLI to allow non-interactive mode for
build,deploy, andsynccommands.
changed
- Changed the Retool API to support updating direct sharing permissions for apps and folders via new endpoints.
- Changed multi-step functions to be generally available.
removed
- Removed
Inspect in Debug Modaloption in the State sidebar. - Removed
setOutputmodule from the Event handler UI.
Self-hosted Retool 3.188
No longer supported
Patch release notes
Apr 16, 2025
added
- Added
workflowContextto the list of inputs for blocks. - Added ability for users to search workflow logs by
pluginId.
fixed
- Fixed an issue where incorrect Table rows were being edited.
- Fixed an issue with disabling Form submission in modules, ensuring consistent behavior.
- Fixed an issue where Alert click events were not specific to the current action.
- Fixed the loading state of Forms embedded in modules, ensuring submit buttons properly display loading state.
- Fixed an inconsistency between workflow status shown in the UI and the
isEnabledvalue returned by the/workflowsendpoint. - Fixed an inconsistency between workflow status shown in the UI and the
isEnabledvalue returned by the/workflows/{workflowId}endpoint. - Fixed an issue with the Manage time zone date format option in Table and Key Value.
- Fixed an issue where SAML JIT users weren`t being added to the external users group.
- Fixed an issue where Alert value editor sometimes started in FX mode when first added to the canvas.
- Fixed an issue with same-page scoping on OpenAPI queries.
improved
- Improved design of the Debug Tools state with minor fixes.
changed
- Changed workflow names to include the date by default.
Self-hosted Retool 3.185
No longer supported
Patch release notes
Apr 9, 2025
added
- Added GET endpoints for
/workflowand/workflow/{id}to the OpenAPI specification for Retool API. - Added rate limiting for Retool Storage retrievals.
- Added an option to disable URL encoding in the REST API resource.
fixed
- Fixed an issue with save/cancel action buttons on Table cells.
- Fixed an issue with save/cancel action buttons on Table cells.
improved
- Improved the user interface of Retool Database.
- Improved Alert component text visibility in dark themes and added more color configuration options.
changed
- Changed permission group rules to prevent duplicate group names with case-insensitive matching.
- Changed the error message that appears when a user attempts to put a Module inside a List View.
Self-hosted Retool 3.179
No longer supported
Patch release notes
Apr 2, 2025
added
- Added new environment variable
RETOOL_CLIENT_MAX_BODY_SIZEto set the maximum request size Retool will accept. - Added
Set URL Parametersevent handler method in single page apps.
fixed
- Fixed an issue where shared events were not shown when bulk editing components. Now, if any of the components selected have no events, "no shared events" is shown.
improved
- Improved
Click Cellevent handlers to activate when clicking on white space in a cell.
changed
- Changed the location of the Use example JSON button.
Self-hosted Retool 3.178
No longer supported
Patch release notes
Mar 27, 2025
added
- Added the ability to invite users when directly sharing a folder.
- Added new filters to the workflow run panel.
- Added an API for fetching third-party analytics integrations settings.
- Added the ability to filter
GET /apps/API to only show apps using a specified resource. - Added "Create page" and "Toggle pages panel" actions to the command palette.
- Added block name search functionality to workflows.
- Added new filter in workflow run log.
fixed
- Fixed an issue where some components had a duplicate editor for
maintainSpaceWhenHidden. - Fixed icon regression.
- Fixed an issue with autocomplete for column names in Table filters.
- Fixed an issue where database connections may be closed sooner than intended.
- Fixed a recurrent issue with loading the mobile app editor when
SANDBOX_DOMAINenv variable is set. - Fixed an issue where SSH-tunneled resource connections may be closed unnecessarily.
- Fixed an issue that added excessive
nullvalues toallowedGroupIdtemplate fields. - Fixed an issue where the Add Row shortcut could interfere with the Save Cell shortcut in Retool Database.
- Fixed an issue where setting table row height to
dynamiccaused problems when typing.
improved
- Improved Table component by showing tooltip for disabled row actions.
- Improved Inspector to reflect when bulk editing components have different values for the same property.
- Improved bulk editing for image file inputs to display mixed values.
- Improved bulk editing by wrapping add-ons and validation editors in a similar style.
- Improved bulk editing for button type to display mixed values.
Self-hosted Retool 3.170
No longer supported
Patch release notes
Mar 14, 2025
added
- Added support for bulk editing event handlers for components of the same type
- Added the option to specify a custom entityID for SAML SSO
- Added top-level navigation on user interaction for custom components
fixed
- Fixed an issue where clicking on a folder crashed the IDE
improved
- Improved header tooltip to display multi-selected components for bulk editing
security-fix
- Patched CVE-2025-29774 in
xml-crypto. - Patched CVE-2025-29774 in
xml-crypto.
Self-hosted Retool 3.168
No longer supported
Patch release notes
Mar 12, 2025
added
- Added
getAccessTokenAPI for querying a specific token by ID. - Added Wait block to Add Block menu in Retool Workflows.
- Added an API endpoint to invalidate all login sessions for all users of an organization.
- Added ability to directly share an app folder with users.
- Added secret manager to OAuth2 and Custom Auth flows.
- Added public API endpoints to configure AI settings.
- Changed workflow execution permissions in apps to require workflow view access.
- Added an error message for disabled users attempting to sign in via SAML SSO.
- Added new file upload endpoints for Slack to replace the deprecated
files.uploadfunctionality.
fixed
- Fixed an issue where the Alert component would change theme tokens to hex values.
- Fixed an issue where
Insert DocumentVector Action did not work for vectors usingtext-embedding-3-largeembeddings model. - Fixed an issue where Retool Database resource settings were not used in non-production environments.
- Fixed an issue with resource connection pooling causing errors during multiple concurrent queries.
- Fixed an issue with protecting interdependent apps and workflows.
- Fixed an issue where clicking on a folder crashed the IDE.
improved
- Improved gRPC query performance for services with numerous APIs.
Self-hosted Retool 3.163
No longer supported
Patch release notes
Mar 5, 2025
added
- Added
updated_atandcreated_attimestamps to all accessRequests API endpoints.
fixed
- Fixed an issue where changing column width and editing a table cell threw an error, preventing proper cell editing.
- Fixed an issue where custom authentication may report an error during a non-auth step.
- Fixed URL escaping response for mobile redirects.
- Fixed alignment of icons in the settings page theme listing.
- Fixed an issue with persist row selection and server-side pagination that prevented batch unselection of rows.
improved
- Improved error messages to be more user-friendly.
- Improved Android startup and runtime performance.
- Improved readability of longer group names.
changed
- Changed component documentation links to reference the guide for the component when available, instead of the component reference.
- Changed the order of State properties to be ordered alphabetically, case-insensitive.
- Changed Boolean cells in the Table component to show with full opacity, regardless of whether they are editable.
Self-hosted Retool 3.159
No longer supported
Patch release notes
Feb 26, 2025
added
- Added a documentation link for Cascader in the Inspector.
- Added frontend and backend validation to prevent app state saves from being overwritten.
fixed
- Fixed an issue where scheduled workflows could not reference example input data.
- Fixed an issue with Cascader where defining an option to be its own parent caused a crash. Options that are their own parent are now considered root options.
- Fixed an issue with loading modules.
- Fixed an issue where licensed seat limits weren`t enforced for some airgapped users.
- Fixed an issue where single page PDFs could not be rotated in the PDF component.
- Fixed an issue where some upgraded Cascaders had incorrect structure in the Inspector.
- Fixed an issue where specifying a branch for embed API requests didn`t work.
- Fixed an issue where page-scoped queries were incorrectly being shown as out of scope after the page was renamed.
- Fixed a bug where membership in many workspaces would preventaccessing the user tools menu.
- Fixed an issue where large List Views sometimes crashed from too many re-renders.
improved
- Improved the messages on the landing page when the Published, Drafts, and Trash tabs are empty.
removed
- Removed the ability to create a global error handler in a multistep function.
security-fix
- Fixed a bug where the responses for previewed queries were not properly sanitized. Sanitization in preview queries is now at parity with sanitization in regular query.
Self-hosted Retool 3.156
No longer supported
Patch release notes
Feb 19, 2025
fixed
- Fixed an issue with streamed query timeouts for Postgres resources.
- Fixed an issue with the automatic branch cleanup beta feature where cloud branches weren`t properly deleted.
- Fixed an issue where scheduled workflows could not reference example input data.
Self-hosted Retool 3.149
No longer supported
Patch release notes
Feb 6, 2025
added
- Added shadow styles for components and new shadow theme properties.
- Added undo/redo keyboard shortcut functionality for the theme editor.
- Added execution modes to the Workflow block, allowing users to choose between pausing the parent workflow or queuing the child workflow.
- Added support for multi-step workflows in public beta on self-hosted organizations.
fixed
- Fixed an issue with two-factor authentication redirects for FIDO2 users.
- Fixed an issue where Navigation component event handlers were disappearing when added as children to other events.
- Fixed a misspelled icon name.
- Fixed an issue in the Custom Auth settings where a field didn`t support autocomplete and incorrectly showed "undefined" warnings for environment variables.
Self-hosted Retool 3.144
No longer supported
Patch release notes
Jan 29, 2025
added
- Added the ability to undo and redo changes in the theme editor with keyboard shortcuts.
fixed
- Fixed an issue where dragging the pop-out editor for style editors would not work.
- Fixes a regression where modules in "expand to fit" containers would not scroll.
- Fixed an issue where JIT-provisioned users were not added to the External Users group.
- Fixed an issue with container borders where they covered small shadows.
- Fixed the module tutorial close button, which was previously invisible.
- Fixed an issue with FIDO2 authentication redirects.
changed
- Changed border radius setting to allow full border radius CSS syntax.
Self-hosted Retool 3.139
No longer supported
Patch release notes
Jan 22, 2025
added
- Added an error that is logged to the console if the browser fails to load JavaScript files necessary for rendering custom components.
- Added a hover tooltip for some instances of truncated text in style editors.
fixed
- Fixed focus state and layout shift for multiline contents in style editors.
- Fixed the MySQL connector version 2.0 to support variable assignment.
- Fixed an issue where margin and padding properties were not searchable in the Code search tab.
Self-hosted Retool 3.136
No longer supported
Patch release notes
Jan 16, 2025
added
- Added support for localizing public apps.
Self-hosted Retool 3.135
No longer supported
Patch release notes
Jan 10, 2025
added
- Added the ability for multipage users to add page-scoped keyboard shortcuts. These override globally-scoped custom keyboard shortcuts.
- Added border-radius style property to Listbox component.
- Added an error message to indicate rate limiting for custom components.
- Added support for multi-instance releases. This feature is in beta and can be enabled from the Settings > Beta page. Contact Support if you`d like to be added to the Beta.
fixed
- Fixed an issue with loading the mobile app editor while having the
SANDBOX_DOMAINenvironment variable set. - Fixed an issue with the Chat component not permanently removing message history.
- Fixed an issue with the Chat component so that the empty state is centered when the message goes to multiple lines.
- Fixed a bug that would cause issues with virtualization of dropdown items in a Select component when using a larger font size.
- Fixed an issue causing a redirect loop for 2FA-enabled logins.
Self-hosted Retool 3.131
No longer supported
Patch release notes
Jan 2, 2025
added
- Added support for viewing and deleting registered push notification applications from Mobile Advanced Settings.
- Added a new editor option that controls whether the label text of a Button wraps (default behavior) or truncates (new option).
[...]
